# -*- coding: utf-8 -*-
import copy
import hmac
import json
import os
import requests
import sys
import time
import urllib
from binascii import a2b_base64

from hashlib import sha1
from xml.dom.minidom import Document
from ...webStore.Aliexpress.conf import STORE_DICT_LIST

reload(sys)
sys.setdefaultencoding('utf-8')


def create_xml_node_list(name, *param_list):


    node_xml = doc.createElement(name)

    for values in param_list:

        key = str(name)

        if type(values) in [float, int, str, bool, unicode]:
            value_node = doc.createElement('value')
            value_node_text = doc.createTextNode(values)
            value_node.appendChild(value_node_text)
            node_xml.appendChild(node_xml)
        elif type(values) is dict:
            node_temp = create_xml_node_dict(key,**values)
            node_xml.appendChild(node_temp)
        elif type(values) is list:
            node_temp = create_xml_node_list(key,*values)
            node_xml.appendChild(node_temp)
    return node_xml


def create_xml_node_dict(name, **param_dict):

    node_xml = doc.createElement(name)

    for key in param_dict:
        values = param_dict[key]
        if type(values) in [float, int, str, bool, unicode]:
            node_xml.setAttribute(key, str(values))
        elif type(values) is dict:
            if key == 'names':
                node_xml.setAttribute(key+'_zh', str(values['zh']))
            node_temp = create_xml_node_dict(key,**values)
            node_xml.appendChild(node_temp)
        elif type(values) is list:
            node_temp = create_xml_node_list(key,*values)
            node_xml.appendChild(node_temp)
        else:
            print 'know',key,type(values)


    return node_xml


doc = Document()

class Aliexpress(object):
    '''
    对速卖通的接口api做一个整合，主要设计到产品上架相关接口
    以及之后需要处理的订单下载接口
    '''

    app_key = 'app_key'
    secret_key = 'secret_key'
    refresh_token = "refresh_token"
    refresh_token_timeout = "refresh_token_timeout"
    access_token = 'access_token'
    code = 'code'

    redirect_uri = 'http://elm.starmerx.com:8001/order/get_code/'
    site = 'aliexpress'
    state = 'starmerx'


    service = {
        'code' : 'http://authhz.alibaba.com',
        'auth' : 'https://hzapi.alibaba.com',
        'common' : 'https://hzapi.alibaba.com',
    }

    class_command = {
        'code' : '/auth/',
        'auth' : '/openapi/',
        'common' : '/openapi/',
    }

    command = {
        'code' : 'authorize.htm',
        'auth' : 'param2/1/system.oauth2/',
        'common' : 'param2/1/aliexpress.open/',
    }

    function_command = {
        'get_token' : 'getToken',
        'get_product_info':'api.findAeProductById',
        'get_child_attributes_result_cateory_id_and_path' : 'getChildAttributesResultByPostCateIdAndPath',
        'list_freight_template' : 'api.listFreightTemplate',
        'get_product_group_list' : 'api.getProductGroupList',
        'query_promise_template_id' : 'api.queryPromiseTemplateById',
        'post_aliexpress_product' : 'api.postAeProduct',
        'size_model_required' : 'sizeModelIsRequiredForPostCat',
        'refresh_access_token' : 'getToken',
        'refresh_refresh_token' : 'postponeToken',
        'get_children_category' : 'api.getChildrenPostCategoryById',
        'upload_temp_image' : 'api.uploadTempImage',
        'upload_image' : 'api.uploadImage',
        'get_image_group_list' : 'api.listGroup',

	'get_online_logistics_info':'api.getOnlineLogisticsInfo',
        'get_order_list' : 'api.findOrderListQuery',
        'get_order' : 'api.findOrderById',
        'upload_track' : 'api.sellerShipment',
        'send_order_msg' : 'api.addMsg',
        'get_print_info' : 'api.getPrintInfos',
	'create_warehouse_order' : 'api.createWarehouseOrder',
        'getToken' : 'getToken',
        'getToken' : 'getToken',
        'getToken' : 'getToken',
        'getToken' : 'getToken',
        'getToken' : 'getToken',
        'findAeProductDetailModuleListByQurey':'api.findAeProductDetailModuleListByQurey',
        'getPhotoBankInfo':'api.getPhotoBankInfo',
        'listImagePagination':'api.listImagePagination',
        'getSizeChartInfoByCategoryId':'api.getSizeChartInfoByCategoryId',
        'getPostCategoryById':'api.getPostCategoryById',
        'findProductInfoListQuery':'api.findProductInfoListQuery',
        'queryProductViewedInfoEverydayById':'api.queryProductViewedInfoEverydayById',
        'queryProductExposedInfoEverydayById': 'api.queryProductExposedInfoEverydayById',
        'queryProductSalesInfoEverydayById': 'api.queryProductSalesInfoEverydayById',
        'queryProductFavoritedInfoEverydayById':'api.queryProductFavoritedInfoEverydayById',
        'queryProductBusinessInfoById':'api.queryProductBusinessInfoById',
        'queryProductAddCartInfoEverydayById': 'api.queryProductAddCartInfoEverydayById',
        'findAeProductById': 'api.findAeProductById',
        'offlineAeProduct':'api.offlineAeProduct',
        'queryIssueList':'api.queryIssueList',
        'editSingleSkuPrice':'api.editSingleSkuPrice',
        'editSingleSkuStock':'api.editSingleSkuStock',
        'renewExpire':'alibaba.ae.product.renewExpire',
        'get_shipment':'api.getOnlineLogisticsInfo',
        
    }

    def __init__(self, app_key=None, secret_key=None, refresh_token=None, access_token=None, code=None,proxy=False,proxy_url='ali'):
        if app_key and secret_key:

            self.app_key = app_key
            self.secret_key = secret_key
            self.proxy = proxy
            self.proxy_host = 'http://139.196.33.73:8234/marketplaces/ali_service/'
            if proxy_url == 'ec2':
                self.proxy_host = 'http://54.89.124.145:8234/marketplaces/ali_service/'
            #self.proxy_host = 'http://127.0.0.1:8234/marketplaces/ali_service/'

            if refresh_token:
                self.refresh_token = refresh_token
                if access_token:
                    self.access_token = access_token
                else:
                    params = {
                        'grant_type':"refresh_token",
                        'need_refresh_token':'true',
                    }
                    self.refresh_access_token(**params)

            else:
                if not code:
                    url = self.get_authorize_url()
                    print url
                    print '请注意授权'
                else:
                    print 'create code'
                    code_dict = {
                        'grant_type':"authorization_code",
                        'need_refresh_token':'true',
                        'redirect_uri': self.redirect_uri,
                        'code':code,
                    }
                    self.get_token(**code_dict)


    def __str__(self):
        return 'appKey:' +  self.app_key + ',secret_key:' + self.secret_key + ',refresh_token:' + self.refresh_token + ',access_token:' + self.access_token

    def __calc_signature(self, command, params_map):
        """Calculate MWS signature to interface with Amazon
        """

        # 因为授权的时候，只需要对参数进行签名计算，不需要对url进行签名计算
        str_base = command if command.find('auth') == -1 else ''

        params_map1 = sorted(params_map)
        for each in params_map1:
            str_base  = str_base + str(each) + str(params_map[each])

	str_base = str_base.replace('domesticLogisticsCompany上门揽收domesticLogisticsCompanyId-1','domesticLogisticsCompanyId-1domesticLogisticsCompany上门揽收')
        return hmac.new(str(self.secret_key), str(str_base), sha1).digest().encode('hex').upper()



    def __make_call_proxy(self, url, data=None, header=None):
        """
        通过代理服务器实际发送请求
        :param url: 需要调用的url
        :param data:
        :param header:
        :return:
        """
        _data = {'data':data,'url':url,'headers':header}
        print _data
        import urllib2
        try:
            return eval(urllib2.urlopen(self.proxy_host,urllib.urlencode(_data)).read())
        except Exception as e:
            print 'Unkown error:', str(e)
            if str(e).find('timed out') != '-1':
                print 'Unkown error: request again'
                try:
                    return eval(urllib2.urlopen(self.proxy_host, urllib.urlencode(_data)).read())
                except Exception as e:
                    return {'exception':'timed out','message':'timed out','error_code':'0'}
            else:
                return {'exception': 'timed out', 'message': 'timed out','error_code':0}

    def __make_call(self, url, data=None, header=None):
        """
        :param url:需要调用的url
        :return:返回通过post请求，得到对于的url的返回值
        """
        if self.proxy:
            r = self.__make_call_proxy(url, data=data, header=header)
            return r
        else:
            r = requests.post(url, data=data, headers=header)
            result_json = json.loads(r.text)
            # print r.text
            result_json = json.loads(r.text)
            return result_json

    def __make_call_deal(self, service_type, function_type, params={}):
        """
        主要对各调用的一个封装，将请求之类的参数之类的通过公共参数给配置好，方便以后的修改
        :param args:传入的list
        :param kwargs: 传入的dict
        :return:返回请求的结果
        """

        service, class_command, commond, function_command = self.service[service_type], self.class_command[service_type], self.command[service_type],self.function_command[function_type]
        headers={"Content-type": "application/x-www-form-urlencoded", "Accept": "text/plain"}

        total_params = copy.deepcopy(params)
        url_params = {}
        # 如果要检查签名bug，则需要去掉时间戳，不然时间戳影响签名算法
        #url_params['_aop_timestamp'] = str(int(time.time() * 1000))

        total_params.update(url_params)

        url_params['_aop_signature'] = self.__calc_signature(commond + function_command + '/' + str(self.app_key), total_params)

        request_url = service + class_command + commond + function_command + '/' + str(self.app_key) + '?' + urllib.urlencode(url_params)

        # print '-----------------------------'
        # print params
        # print '-----------------------------'
        # print request_url
        # print '-----------------------------'

        # r = requests.post(request_url, data=params, headers=headers)
        #
        # print r
        # result_data = json.loads(r.text)
        #
        # return result_data
        print 'request_url--------------------------', request_url


        return self.__make_call(request_url, params, headers)

    def get_authorize_url(self):
        """
        :return:返回alibaba授权的url
        授权成功之后得到一个url： self.redirect_uri + state=self.state&code=ede9c269-10d3-44ca-88d6-53030311de04
        """

        service_type = 'code'
        params_map = {
            'client_id': self.app_key,
            'redirect_uri' : self.redirect_uri,
            'site': self.site,
            'state' : self.state,
        }

        # print self.command[service_type]


        params_map['_aop_signature'] = self.__calc_signature(self.command[service_type], params_map)

        params_map_str =  '&'.join([key + '=' + params_map[key] for key in params_map])

        url = self.service[service_type] + self.class_command[service_type] + self.command[service_type] + '?' + params_map_str

        return url


    def get_token(self, **params):
        """
        :param params:
            {
                'grant_type':"authorization_code",
                'need_refresh_token':'true',
                'redirect_uri': self.redirect_uri,
                'code':code,
            }
        :return:
        """
        service_type = 'auth'
        function_type = 'get_token'

        params.update({
            'client_id' : self.app_key,
            'client_secret' : self.secret_key,
            'grant_type':'authorization_code',
            'need_refresh_token':'true',
            'redirect_uri':self.redirect_uri,
        })

        result_json = self.__make_call_deal(service_type, function_type, params)

        print result_json

        self.refresh_token_timeout, self.refresh_token, self.access_token = result_json['refresh_token_timeout'], result_json['refresh_token'], result_json['access_token']
        self.redirect_uri = params.get('redirect_uri', None) or self.redirect_uri

        return True

    def refresh_access_token(self, **params):
        """
        :param params:
            {
                'grant_type':"refresh_token",
                'need_refresh_token':'true',
            }
        :return:
        """

        service_type = 'auth'
        function_type = 'refresh_access_token'
        params.update({
            'client_id' : self.app_key,
            'client_secret' : self.secret_key,
            'refresh_token' : self.refresh_token,
        })

        result_json = self.__make_call_deal(service_type, function_type, params)
        print result_json

        self.access_token = result_json['access_token']

        return True
    
    def refresh_refresh_token(self, **params):
        """
        :param params:
            {
                'grant_type':"refresh_token",
                'need_refresh_token':'true',
            }
        :return:
        """
        

        service_type = 'auth'
        function_type = 'refresh_refresh_token'
        params.update({
            'client_id' : self.app_key,
            'client_secret' : self.secret_key,
            'refresh_token' : self.refresh_token,
            'access_token' : self.access_token
        })
        result_json = self.__make_call_deal(service_type, function_type, params)
        result_json.pop('expires_in')
        return result_json

    def set_refresh_token_postpone_token(self, **params):
        """
        :param params:
        :return:
        """

        service_type = 'auth'
        function_type = 'set_refresh_token_postpone_token'

        params.update({
            'client_id' : self.app_key,
            'client_secret' : self.secret_key,
            'refresh_token' : self.refresh_token,
        })

        result_json = self.__make_call_(service_type, function_type, params)

        self.refresh_token_timeout, self.refresh_token, self.access_token  = result_json['refresh_token_timeout'], result_json['refresh_token'], result_json['access_token']

        return True

    def get_child_attributes_result_cateory_id_and_path(self, **params):
        """
        :param params:
            {
                'cateId':"category_id",
                'parentAttrValueList':'parentAttrValueList',
            }
        :return:返回属性列表，抓取状态
        """

        service_type = 'common'
        function_type = 'get_child_attributes_result_cateory_id_and_path'

        params.update({
            'access_token': self.access_token,
        })

        result_json =  self.__make_call_deal(service_type, function_type, params)
        print 'result_json,-------------------',result_json

        return result_json['attributes'], result_json['success']

    def list_freight_template(self, **params):
        """
        :param params:
            {}
        :return:返回本店的运费模板信息，抓取状态，错误描述
        """
        service_type = 'common'
        function_type = 'list_freight_template'

        params.update({
            'access_token': self.access_token,
        })

        return self.__make_call_deal(service_type, function_type, params)

        # return result_json['aeopFreightTemplateDTOList'], result_json['success'], result_json.get('errorDesc','')

    def get_product_group_list(self, **params):
        """
        :param params:
            {}
        :return:返回本店的运费模板信息，抓取状态，错误描述
        """
        service_type = 'common'
        function_type = 'get_product_group_list'
        params.update({
            'access_token': self.access_token,
        })
        return self.__make_call_deal(service_type, function_type, params)
        # return result_json['target'], result_json['success'], result_json['timeStamp']

    def get_image_group_list(self, **params):
        """
        :param params:
            {}
        :return:返回本店的运费模板信息，抓取状态，错误描述
        """
        service_type = 'common'
        function_type = 'get_image_group_list'
        params.update({
            'access_token': self.access_token,
        })
        return self.__make_call_deal(service_type, function_type, params)
        # return result_json['target'], result_json['success'], result_json['timeStamp']


    def query_promise_template_id(self, **params):
        """
        :param params:
            {'TemplateId' : '-1}
        :return:返回本店的服务模板信息
        """
        service_type = 'common'
        function_type = 'query_promise_template_id'

        params.update({
            'access_token': self.access_token,
        })

        return self.__make_call_deal(service_type, function_type, params)

        # return result_json['templateList']

    def post_aliexpress_product(self, **params):
        """
        :param **params:传入的产品信息的字典
        :return:返回上传之后的产品ID，和上传状态
        """
        service_type = 'common'
        function_type = 'post_aliexpress_product'

        params.update({
            'access_token': self.access_token,
        })

        return self.__make_call_deal(service_type, function_type, params)

        # return result_json['productId'], result_json['success']

    def size_model_required(self, **params):
        """
        :param params:需要抓取的品类ID
            {'cateId' : 'cateId'}
        :return:返回属性列表，抓取状态
        """
        service_type = 'common'
        function_type = 'query_promise_template_id'

        params.update({
            'access_token': self.access_token,
        })
        return self.__make_call_deal(service_type, function_type, params)

        # return result_json['attributes'], result_json['success']

    def get_children_category(self, **params):
        """
        :param params:
         {'cateId':'0'}
        :return:
        返回该品类的子品类信息
        """
        service_type = 'common'
        function_type = 'get_children_category'

        params.update({
            'access_token': self.access_token,
        })
        return self.__make_call_deal(service_type, function_type, params)

        # return result_json['aeopPostCategoryList'], result_json['success']

    def upload_temp_image(self,image_data, **params):
        """
        :param params:
         {'srcFileName':'51m-uHIMGjL.jpg'}
        :return:
        上传一个图片到速卖通上去，返回url值信息
        """

        service_type = 'common'
        function_type = 'upload_temp_image'

        params.update({
            'access_token': self.access_token,
        })

        url =  self.service[service_type] + self.class_command[service_type] + self.command[service_type] + self.function_command[function_type] + '/' + str(self.app_key) + '?' + urllib.urlencode(params)

        r = requests.post(url, image_data)
        # print r.text
        result_json = json.loads(r.text)

        return result_json
        # return result_json['url'], result_json['srcFileName'],result_json['width'], result_json['height'],result_json['success']

    def upload_image(self, image_data, **params):
        """
        :param params:
         {'srcFileName':'51m-uHIMGjL.jpg'}
        :return:
        上传一个图片到速卖通上去，返回url值信息，这里还有点问题，不知道图片数据参与不参与签名，所以用临时的先吧。
        """

        service_type = 'common'
        function_type = 'upload_image'

        params.update({
            'access_token': self.access_token,
        })

        params['_aop_signature'] = self.__calc_signature(self.command[service_type] + self.function_command[function_type] + '/' + str(self.app_key), params)

        url =  self.service[service_type] + self.class_command[service_type] + self.command[service_type] + self.function_command[function_type] + '/' + str(self.app_key) + '?' + urllib.urlencode(params)
        print url
        r = requests.post(url,image_data)
        # print r.text
        result_json = json.loads(r.text)

        return result_json
        # ['url'], result_json['srcFileName'],result_json['width'], result_json['height'],result_json['success']

    def upload_image_proxy(self,image_url,**params):
        """
        :param params:
         {'srcFileName':'51m-uHIMGjL.jpg'}
        :return:
        上传一个图片到速卖通上去，返回url值信息，这里还有点问题，不知道图片数据参与不参与签名，所以用临时的先吧。
        """
        try:
            params.pop('proxy_url')
        except:
            pass
        service_type = 'common'
        function_type = 'upload_image'

        params.update({
            'access_token': self.access_token,
        })

        # params['_aop_signature'] = self.__calc_signature(self.command[service_type] + self.function_command[function_type] + '/' + str(self.app_key), params)

        url =  self.service[service_type] + self.class_command[service_type] + self.command[service_type] + self.function_command[function_type] + '/' + str(self.app_key)

        return self.__make_call_proxy(url,{'image_url':image_url,'params':params},header={'base_sign':self.command[service_type] + self.function_command[function_type] + '/' + str(self.app_key),'secret_key':self.secret_key})


    def get_online_logistics_info(self,**params):
        """
        :param params:
        {}
        :return :返回本店线上发货订单的发货信息，错误描述
        """
        service_type = 'common'
        function_type = 'get_online_logistics_info'
        params.update({
            'access_token':self.access_token
                       })
        return self.__make_call_deal(service_type, function_type, params)

    def get_order_list(self, **params):
        """
        :param params:
            {}
        :return:返回本店的运费模板信息，抓取状态，错误描述
        """
        service_type = 'common'
        function_type = 'get_order_list'
        params.update({
            'access_token': self.access_token,
        })
        return self.__make_call_deal(service_type, function_type, params)
        # return result_json['target'], result_json['success'], result_json['timeStamp']


    def get_order(self, **params):
        """
        :param params:
            {}
        :return:返回本店的运费模板信息，抓取状态，错误描述
        """
        service_type = 'common'
        function_type = 'get_order'
        params.update({
            'access_token': self.access_token,
        })
        return self.__make_call_deal(service_type, function_type, params)
        # return result_json['target'], result_json['success'], result_json['timeStamp']

    def get_shipment(self,**params):
        service_type = 'common'
        function_type = 'get_shipment'
        params.update({
            'access_token': self.access_token,
        })
        return self.__make_call_deal(service_type, function_type, params)

    def get_print_info(self, **params):
        """
        :param params:
            {}
        :return:返回本店的运费模板信息，抓取状态，错误描述
        """
        service_type = 'common'
        function_type = 'get_print_info'
        params.update({
            'access_token': self.access_token,
        })
        return self.__make_call_deal(service_type, function_type, params)
    def create_warehouse_order(self,**params):
        """
        :param params:
            {}
        :return:创建运单，返回结果，错误描述
        """
        service_type = 'common'
        function_type = 'create_warehouse_order'
        params.update({
            'access_token': self.access_token,
        })
        
        params['_aop_signature'] = self.__calc_signature(self.command[service_type] + self.function_command[function_type] + "/" + str(self.app_key), params)
        
        url =  self.service[service_type] + self.class_command[service_type] + self.command[service_type] + self.function_command[function_type] + '/' + str(self.app_key) + '?' + urllib.urlencode(params)
        headers={"Content-type" : "application/x-www-form-urlencoded", "Accept" : "text/plain","charset":"UTF-8"}
        r = requests.get(url,headers=headers)
        print r.text
        result_json = json.loads(r.text)
        return result_json

    def get_category_tree(self, cateId=0):
        """
        :return:获取站点的品类结构
        """

        temp_dict = {'cateId' : cateId}
        result_json_1 = a.get_children_category(**temp_dict)
        if result_json_1.get('success', False):
            category_list =  result_json_1.get('aeopPostCategoryList', [])
        else:
            category_list = []
            print 'Download root category error:', temp_dict['cateId']


        field_list = ['id','level', 'names_zh', 'names_en', 'isleaf']
        for category_dict in category_list:
            # print category_dict['id'], category_dict['level'], category_dict['names']['zh'], category_dict['names']['en']

            tt = {'cateId':category_dict['id']}
            result_json = self.get_child_attributes_result_cateory_id_and_path(**tt)

            if result_json.get('success', False):
                attributes =  result_json.get('attributes', [])
            else:
                attributes = []
                print 'down load get_child_attributes_result_cateory_id_and_path error: ', tt
                continue

            with open('category.csv', 'aw') as f:
                fl = [str(category_dict[field]) if field.split('_').__len__() == 1 else category_dict[field.split('_')[0]][field.split('_')[1]]  for field in field_list]
                fl.append(str(attributes))
                f.write('\t'.join(fl) + '\n')


            if not category_dict['isleaf']:
                self.get_category_tree(category_dict['id'])
    def upload_track(self,**params):
        """
        :todo :订单回传
        :param params:
         {}
        :return:
        """
        service_type = 'common'
        function_type = 'upload_track'
        params.update({
            'access_token': self.access_token,
        })
        return self.__make_call_deal(service_type, function_type, params)

    def send_order_msg(self,**params):
        '''
        :todo :填加留言
        :return:
        '''
        service_type = 'common'
        function_type = 'send_order_msg'
        params.update({
            'access_token': self.access_token,
        })
        return self.__make_call_deal(service_type, function_type, params)

    def get_category_xml_node(self, cateId=0, deep=True):
        """
        通过品类ID，找到对于的子结点信息，并将其封装进入xml的node结点，并返回，
        由于用的是深度遍历，用的迭代算法，不好控制层数，这里最好可以改成广度遍历，就好控制遍历的层数
        :param cateId: 入口的品类ID
        :param deep: 是否便利超过1层
        :return: 返回xml的结点
        """

        name = 'category_' + str(cateId)
        node_list = []

        # node_xml = doc.createElement(name)

        temp_dict = {'cateId' : cateId}
        result_json_1 = a.get_children_category(**temp_dict)
        # print result_json_1
        if result_json_1.get('success', False):
            category_list =  result_json_1.get('aeopPostCategoryList', [])
        else:
            category_list = []
            print 'Download root category error:', temp_dict['cateId']


        id = 0
        for category_dict in category_list:
            id = id +1
            tt = {'cateId':category_dict['id']}
            print category_dict['id']
            result_json = self.get_child_attributes_result_cateory_id_and_path(**tt)
            if result_json.get('success', False):
                attributes =  result_json.get('attributes', [])
            else:
                attributes = []
                print 'down load get_child_attributes_result_cateory_id_and_path error: ', tt
                continue

            category_dict['attr'] = attributes
            xml_node = create_xml_node_dict(name + '_' + str(id), **category_dict)
            if not category_dict['isleaf'] and deep:
                xml_node_child_list = self.get_category_xml_node(category_dict['id'])
                for xml_node_child in xml_node_child_list:
                    xml_node.appendChild(xml_node_child)
            node_list.append(xml_node)

        return node_list

    def create_category_xml(self, cateId=0, deep=True):
        """
        根据品类ID，获取对应的自节点信息，并写成xml文件
        :param cateId: 入口的品类ID
        :param deep: 是否便利超过1层
        :return: 返回xml文件名称
        """

        category_tree = doc.createElement('category_tree') #创建根元素
        category_tree.setAttribute('xmlns:xsi',"http://www.w3.org/2001/XMLSchema-instance")#设置命名空间
        doc.appendChild(category_tree)

        cateogry_xml_node_list = a.get_category_xml_node(cateId=cateId,  deep=deep)

        for cateogry_xml_node in cateogry_xml_node_list:
            category_tree.appendChild(cateogry_xml_node)

        with open('product_xml' + os.sep + str(cateId) + '.xml','w') as f:
            f.write(doc.toprettyxml(indent = ''))

        return 'product_xml' + os.sep  + str(cateId) + '.xml'

    def set_product_defalut_values(self):

        product_upload = {
            'deliveryTime' : '5', #1
            'packageType' : '0',  #0       0
            'lotNum' : '1',  #0              1
            'packageLength' : '20',  #1     20
            'packageWidth' : '10',  #1      30
            'packageHeight' : '10',  #1     40
            'grossWeight' : '0.005',  #1     0.005
            'isPackSell' : '0',  #0     false
            'baseUnit' : '1',  #0    1
            'addUnit' : '2',  #0    2
            'addWeight' : '0.01',  #0  0.5
            'wsValidNum' : '30',  #1  30
            'bulkOrder' : '2',  #0 2
            'bulkDiscount' : '2',  #1 2%
            'reduceStrategy' : 'payment_success_deduct',  #1
            'currencyCode' : 'USD',  #0   USD
        }

        aliexpress_product = {
            'detail' : '[html]', #1
            'aeopAeProductPropertys' : '[{ "attrNameId": 10, "attrValueId": 47 }, {"attrValueId": 493, "attrNameId": 284}]',  #1
            'aeopAeProductSKUs' : '[{"skuPrice" :"3.4","currencyCode" : "USD", "skuCode" :"B00HGMA85M", "skuStock" :"true", "aeopSKUProperty" : [{ "propertyValueId": 193, "skuPropertyId": 14 },{ "propertyValueId": 361386, "skuPropertyId": 5 }]}]',    #1
            'imageURLs' : 'http://kfdown.a.aliimg.com/kf/HTB1ZJcrKXXXXXarXXXXq6xXFXXXe/221252324/HTB1ZJcrKXXXXXarXXXXq6xXFXXXe.jpg:http://kfdown.a.aliimg.com/kf/HTB14C7iKXXXXXbXXpXXq6xXFXXXm/221252324/HTB14C7iKXXXXXbXXpXXq6xXFXXXm.jpg',  #1
            'freightTemplateId' : '703584595',   #1
            'promiseTemplateId' : '0', #0

            'productPrice' : '3.4',   #1
            'subject' : 'Diamond Supply Beanie (Black/White)',    #1
            'categoryId' : '200000634',  #1
            'productUnit' : '100000015',  #1


            'deliveryTime' : '5', #1
            'packageType' : '0',  #0       0
            'lotNum' : '1',  #0              1
            'packageLength' : '20',  #1     20
            'packageWidth' : '10',  #1      30
            'packageHeight' : '10',  #1     40
            'grossWeight' : '0.005',  #1     0.005
            'isPackSell' : '0',  #0     false
            'baseUnit' : '1',  #0    1
            'addUnit' : '2',  #0    2
            'addWeight' : '0.01',  #0  0.5
            'wsValidNum' : '30',  #1  30
            'bulkOrder' : '2',  #0 2
            'bulkDiscount' : '2',  #1 2%
            'reduceStrategy' : 'payment_success_deduct',  #1
            'currencyCode' : 'USD',  #0   USD;RUB
        }
        product = {}


        # product_upload['categoryId'] =

    def __get_product_id(self, product=None):

        return 'product_category_id'

    def __get_store_promise_freight_template(self, store):

        promise_list = self.query_promise_template()
        freight_list = self.list_freight_template()

        return promise_list,  freight_list[0]

    def test_upload_product(self):


        aliexpress_product = {
            'detail' : '<p> just for test</p>', #1
            'aeopAeProductSKUs' : '[{"skuPrice" :"3.4","currencyCode" : "USD", "skuCode" :"B00HGMA85M", "skuStock" :"true", "aeopSKUProperty" : []}]',    #1
            'deliveryTime' : '5', #1
            'promiseTemplateId' : '0',
            'categoryId' : '200000347',  #1
            'subject' : 'Diamond Supply Beanie',    #1
            'productPrice' : '3.4',   #1
            'freightTemplateId' : '1000',   #1
            'imageURLs' : 'http://kfdown.a.aliimg.com/kf/HTB1ZJcrKXXXXXarXXXXq6xXFXXXe/221252324/HTB1ZJcrKXXXXXarXXXXq6xXFXXXe.jpg',  #1
            'productUnit' : '100000015',  #1
            'packageType' : '0',  #0       0
            'lotNum' : '1',  #0              1
            'packageLength' : '20',  #1     20
            'packageWidth' : '10',  #1      30
            'packageHeight' : '10',  #1     40
            'grossWeight' : '0.005',  #1     0.005
            'isPackSell' : '0',  #0     false
            'baseUnit' : '1',  #0    1
            'addUnit' : '2',  #0    2
            'addWeight' : '0.01',  #0  0.5
            'wsValidNum' : '30',  #1  30
            'aeopAeProductPropertys' : '[]',  #1
            'bulkOrder' : '2',  #0 2
            'bulkDiscount' : '2',  #1 2%
            'reduceStrategy' : 'payment_success_deduct',  #1
            'currencyCode' : 'USD',  #0   USD;RUB
        }

        aa = self.post_aliexpress_product(**aliexpress_product)

        print aa


    def tran_internal_product_aliexpress_product(self, internal_product=None):
        aliexpress_product = {
            'detail' : '产品详细信息的html代码', #1
            'aeopAeProductSKUs' : '产品的sku列表',    #1
            'deliveryTime' : '备货期', #1
            'promiseTemplateId' : '服务模板设置', #0
            'categoryId' : '品类ID',  #1
            'subject' : '商品英文名',    #1
            'productPrice' : '商品一口价',   #1
            'freightTemplateId' : '商品运费模板ID',   #1
            'imageURLs' : '主图URL列表',  #1
            'productUnit' : '商品单位',  #1
            'packageType' : '是否打包销售',  #0       0
            'lotNum' : '每包件数',  #0              1
            'packageLength' : '商品包装长度',  #1     20
            'packageWidth' : '商品包装宽度',  #1      30
            'packageHeight' : '商品包装高度',  #1     40
            'grossWeight' : '商品毛重',  #1     0.005
            'isPackSell' : '是否自定义计重',  #0     false
            'baseUnit' : '购买几件以内不增加运费',  #0    1
            'addUnit' : '每增加件数',  #0    2
            'addWeight' : '对应增加的重量',  #0  0.5
            'wsValidNum' : '商品有效天数',  #1  30
            'aeopAeProductPropertys' : '产品属性',  #1
            'bulkOrder' : '批发最小数量',  #0 2
            'bulkDiscount' : '批发打折率',  #1 2%
            'sizechartId' : '尺码表模版ID',  #1
            'reduceStrategy' : '下单减库存(place_order_withhold)和支付减库存(payment_success_deduct)',  #1
            'groupId' : '关联的产品分组ID',  #1   get_product_group_list
            'currencyCode' : '货币单位',  #0   USD;RUB
        }

        pass

    def upload_temp_image_type(self):
        """
        :param templateId:传入的服务模板的ID，默认-1为查询店铺的全部服务模板信息
        :return:返回本店的模板信息
        """
        api_command = '/openapi/param2/1/aliexpress.open/api.queryPromiseTemplateById/' + self.app_key
        params_map = {
            'access_token': self.access_token,
            'srcFileName' : 'hat_image.png',
            'fileData' : 'fileData',
        }
        result_json = self.__make_call_deal(self.api_service, api_command, params_map)

        print result_json
        return result_json['templateList']

    def findAeProductDetailModuleListByQurey(self,**params):
        """
        :param params:
            {
                'cateId':"category_id",
                'parentAttrValueList':'parentAttrValueList',
            }
        :return:返回属性列表，抓取状态
        """
        service_type = 'common'
        function_type = 'findAeProductDetailModuleListByQurey'
        params.update({
            'access_token': self.access_token,
               'moduleStatus':'approved',
             'pageIndex':'1',
        })
        return self.__make_call_deal(service_type, function_type, params)

    def getPhotoBankInfo(self,**params):
        """
        获取图片银行信息
        """
        service_type = 'common'
        function_type = 'getPhotoBankInfo'
        params.update({
            'access_token': self.access_token,
        })
        return self.__make_call_deal(service_type, function_type, params)

    def listImagePagination(self,**params):
        """
        图片列表
        """
        service_type = 'common'
        function_type = 'listImagePagination'
        params.update({
            'access_token': self.access_token,
            'locationType':'ALL_GROUP',
        })
        return self.__make_call_deal(service_type, function_type, params)

    def getSizeChartInfoByCategoryId(self,categoryId,**params):
        """
        根据类目id获得适用的尺码表信息列表
        : param params:
           {
           'categoryId':'', #商品类目Id
           }
        : return {'sizechartDTOlist':尺寸模板列表,'success':'success'}
        """
        service_type = 'common'
        function_type = 'getSizeChartInfoByCategoryId'
        params.update({
            'access_token': self.access_token,
            'categoryId':categoryId,
        })
        return self.__make_call_deal(service_type, function_type, params)


    def getPostCategoryById(self,**params):
        """
        品类查询接口。根据品类Id查询品类信息。
        :@param params:
        {
            'cateId':    Long         #商品id来查询   ,必须

        }
        @return:{
        "aeopPostCategoryList":[ {
        "id":3, "level":0, "names":{
        "zh":"服装","en":"Apparel"}, "isleaf":false}], "success":true}
 
        """
        service_type = "common"
        function_type = "getPostCategoryById"
        params.update({
            'access_token': self.access_token,
            'cateId': params.get("cateId"),
        })
        return self.__make_call_deal(service_type, function_type, params)

    def findProductInfoListQuery(self,  **params):
        """
        商品列表查询接口。主账号可查询所有商品，子账号只可查询自身所属商品。
        :@param params:
        {
            'productStatusType': string  #必须----上架:onSelling ；下架:offline ；审核中:auditing ；审核不通过:editingRequired。
            'productId':    Long         #商品id来查询   ,非必须
            'pageSize':    Integer       #每页数量
            'currentPage': Integer       #当前数量

        }
        @return: {"aeopAEProductDisplayDTOList": 列表 ,"currentPage":当前页 , "totalPage":总页数, "productCount": 产品总数 ,"success": True, }
        """
        service_type = "common"
        function_type = "findProductInfoListQuery"
        params.update({
            'access_token': self.access_token,
            'productStatusType': params.get("productStatusType"),
        })
        if params.get("productId"):
            params.update({
                'productId': params.get("productId", ''),
            })
        elif params.get("pageSize"):
            params.update({
                'pageSize': params.get("pageSize", ''),
            })
        elif params.get("currentPage"):
            params.update({
                'currentPage': params.get("currentPage", ''),
            })
        return self.__make_call_deal(service_type, function_type, params)

    def queryProductViewedInfoEverydayById(self, **params):
        """
        func: 查询商品每日浏览量(该数据仅限30天之内的时间区间数据查询
        @param params{
            productId : 必须
            startDate : 开始日期
            endDate:     结束日期
            currentPage: 当前页
            pageSize  : 每页结果数量
        }
        @return:
        """
        service_type = "common"
        function_type = "queryProductViewedInfoEverydayById"
        params = self.__update_params(**params)
        return self.__make_call_deal(service_type, function_type, params)

    def queryProductExposedInfoEverydayById(self, **params):
        """
        func: 查询商品每天被曝光数据(该数据仅限30天之内的时间区间数据查询
        @param params{
            productId: 必须
            startDate : 开始日期
            endDate:     结束日期
            currentPage: 当前页
            pageSize  : 每页结果数量
        }
        @return: Total
        """
        service_type = "common"
        function_type = "queryProductExposedInfoEverydayById"
        params = self.__update_params(**params)
        return self.__make_call_deal(service_type, function_type, params)

    def queryProductSalesInfoEverydayById(self, **params):
        """
        func: 查询商品每天的销量数据(该数据仅限30天之内的时间区间数据查询
        @param params:{
           productId: 必须
            startDate : 开始日期
            endDate:     结束日期
            currentPage: 当前页
            pageSize  : 每页结果数量
        }
        @return: Total
        """
        service_type = "common"
        function_type = "queryProductSalesInfoEverydayById"
        params = self.__update_params(**params)
        return self.__make_call_deal(service_type, function_type, params)

    def queryProductFavoritedInfoEverydayById(self,**params):
        """
        func: 查询商品每天被收藏的数量(该数据仅限30天之内的时间区间数据查询
        @param params:{
                productId: 必须
                startDate : 开始日期
                endDate:     结束日期
                currentPage: 当前页
                pageSize  : 每页结果数量
            }
        @return: success
        """
        service_type ="common"
        function_type = "queryProductFavoritedInfoEverydayById"
        params = self.__update_params(**params)
        return self.__make_call_deal(service_type, function_type, params)
    def queryProductAddCartInfoEverydayById(self, **params):
        """
        func: 查询商品每日加入购物车数据(该数据仅限30天之内的时间区间数据查询）
        @param params:
        @return:
        """
        service_type = "common"
        function_type = "queryProductAddCartInfoEverydayById"
        params = self.__update_params(**params)
        return self.__make_call_deal(service_type, function_type, params)


    def __update_params(self, **params):
        tmp_params = {}
        tmp_params.update({
            "access_token": self.access_token,
            "productId": params.get("productId"),
        })
        if params.get("startDate") and params.get("endDate"):
            tmp_params.update({
                "startDate": params.get("startDate"),
                "endDate": params.get("endDate"),
            })
        if params.get("currentPage"):
            tmp_params.update({
                "currentPage": params.get("currentPage")
            })
        if params.get("pageSize"):
            tmp_params.update({
                "pageSize": params.get("pageSize")
            })
        return tmp_params

    def queryProductBusinessInfoById(self, **parmas):
        """
        func: 查询商品交易表现
        @param parmas:{
            productId: 必须
        }
        @return:
        """
        service_type = "common"
        function_type = "queryProductBusinessInfoById"
        parmas.update({
            "access_token": self.access_token,
            "productId": parmas.get("productId"),
        })
        return self.__make_call_deal(service_type, function_type, parmas)



    def findAeProductById(self, **params):
        """
        func: 根据商品id查询单个商品的详细信息
        @param params:{
            productId: 必须
        }
        @return:
        """
        service_type = "common"
        function_type = "findAeProductById"
        params.update({
            "access_token": self.access_token,
            "productId": params.get("productId"),
        })
        return self.__make_call_deal(service_type, function_type, params)

    def editAeProduct(self, **params):
        """
        func: 商品编辑接口
        @param params:
        {

        }
        @return:
        """

    def offlineAeProduct(self,**params):

        service_type = "common"
        function_type = "offlineAeProduct"

        params.update({
            "access_token": self.access_token})
        return self.__make_call_deal(service_type, function_type, params)


    def queryIssueList(self,**params):
        service_type = "common"
        function_type = 'queryIssueList'

        params.update({
            "access_token": self.access_token})
        return self.__make_call_deal(service_type, function_type, params)

    def editSingleSkuPrice(self,**params):
        service_type = "common"
        function_type = 'editSingleSkuPrice'
        params.update({
            "access_token": self.access_token})

        return self.__make_call_deal(service_type, function_type, params)

    def editSingleSkuStock(self,**params):
        service_type = "common"
        function_type = 'editSingleSkuStock'
        params.update({
            "access_token": self.access_token})

        return self.__make_call_deal(service_type, function_type, params)
    def renewExpire(self,**params):
        service_type = "common"
        function_type = 'renewExpire'
        params.update({
            "access_token": self.access_token})

        return self.__make_call_deal(service_type, function_type, params)
    def editMutilpleSkuStocks(self,**params):
        service_type = "common"
        function_type = 'editMutilpleSkuStocks'
        params.update({
            "access_token": self.access_token})

        return self.__make_call_deal(service_type, function_type, params)


    def __del_function__(self):
        pass

        #     def seller_shipment(self,access_token,serviceName,logisticsNo,sendType,outRef,description='',trackingWebsite=None):
        #         '''
        #         声明发货
        #       @param param:
        #             _aop_timestamp    String     否    请求时间戳
        #             _aop_signature    String     否     请求签名
        #             access_token    String     是    用户授权令牌
        #
        #             serviceName    String     是    用户选择的实际发货物流服务
        #             logisticsNo    String     是    物流追踪号
        #             description    String    否    备注(只能输入英文，且长度限制在512个字符。）
        #             sendType    String     是    状态包括：全部发货(all)、部分发货(part)
        #             outRef    String     是    用户需要发货的订单id
        #             trackingWebsite    String    否    当serviceName=other的情况时，需要填写对应的追踪网址    //这里我不支持了
        #         api.sellerShipment     Version:1
        #         @return:
        #         '''
        #         Server="gw.api.alibaba.com:80"
        #         Command="/openapi/param2/1/aliexpress.open/api.sellerModifiedShipment/"+self.appKey
        #
        #         params_map = {
        #             'access_token':access_token,
        #             'serviceName':serviceName,
        #             'logisticsNo':logisticsNo,
        #             'sendType':sendType,
        #             'outRef':outRef,
        #             'description':description,
        #             'trackingWebsite':trackingWebsite,
        #             '_aop_timestamp':self.__get_timestamp(),
        #             }
        #         params_map['_aop_signature'] = self.__calc_signature(Command,params_map)
        #
        #         params=urllib.urlencode(params_map)
        #
        #
        #         headers={"Content-type": "application/x-www-form-urlencoded", "Accept": "text/plain"}
        #         conn = httplib.HTTPSConnection(Server)
        #
        #         conn.request('POST',Command,params,headers)
        #         response=conn.getresponse()
        #         data=response.read()
        #         conn.close()
        #
        #     def seller_modified_shipment(self,access_token,oldServiceName,oldLogisticsNo,newServiceName,newLogisticsNo,sendType,outRef,description='',trackingWebsite=None):
        #         '''
        #         修改声明发货
        #       @param param:
        #             _aop_timestamp    String     否    请求时间戳
        #             _aop_signature    String     是    请求签名
        #             access_token    String     是    用户授权令牌
        #             oldServiceName    String     是    用户需要修改的的老的发货物流服务
        #             oldLogisticsNo    String     是    用户需要修改的老的物流追踪号    CP123456789CN
        #             newServiceName    String     是    用户需要修改的的新的发货物流服务
        #             newLogisticsNo    String     是    用户需要修改的老的物流追踪号    CP123456123CN
        #             description    String    否    备注(只能输入英文)
        #             sendType    String     是    状态包括：全部发货(all)、部分发货(part)    all
        #             outRef    String     是    用户需要发货的订单id    60769040695804
        #             trackingWebsite    String    否    当serviceName=other的情况时，需要填写对应的追踪网址
        #         api.sellerModifiedShipment    Version:1
        #         '''
        #         Server="gw.api.alibaba.com:80"
        #         Command="/openapi/param2/1/aliexpress.open/api.sellerModifiedShipment/"+self.appKey
        #
        #         params_map = {
        #             'access_token':access_token,
        #             'oldServiceName':oldServiceName,
        #             'oldLogisticsNo':oldLogisticsNo,
        #             'newServiceName':newServiceName,
        #             'newLogisticsNo':newLogisticsNo,
        #             'sendType':sendType,
        #             'outRef':outRef,
        #             'description':description,
        #             'trackingWebsite':trackingWebsite,
        #             '_aop_timestamp':self.__get_timestamp(),
        #         }
        #         params_map['_aop_signature'] = self.__calc_signature(Command,params_map)
        #
        #         params=urllib.urlencode(params_map)
        #
        #
        #         headers={"Content-type": "application/x-www-form-urlencoded", "Accept": "text/plain"}
        #         conn = httplib.HTTPSConnection(Server)
        #
        #         conn.request('POST',Command,params,headers)
        #         response=conn.getresponse()
        #         data=response.read()
        #         conn.close()
        #
        #     def get_order_by_id(self,access_token,orderId):
        #         '''
        #             交易订单详情查询
        #             @param param:
        #                 _aop_timestamp    String     否    请求时间戳
        #                 _aop_signature    String     否    请求签名
        #                 access_token    String     是    用户授权令牌
        #                 orderId    Long     是    订单Id
        #
        #             api.findOrderById    Version:1
        #
        #             @return:
        #                             {
        #                 'result':True/False,
        #                 'message':'Request is success' or 'Have some error + str(e)'
        #                 'data':JSON or None
        #                             }
        #             '''
        #         if access_token is None:
        #             print 'access_token is None,Please input your access_token.'
        #             return {'result':False,'message':'Have error : access_token is None.','data':{}}
        #
        #         if orderId is None:
        #             print 'orderId is None,Please input your orderId.'
        #             return {'result':False,'message':'Have error  :orderId is None.','data':{}}
        #
        #
        #         Server="gw.api.alibaba.com:80"
        #         Command="/openapi/param2/1/aliexpress.open/api.findOrderById/"+self.appKey
        #
        #         params_map = {
        #             'access_token':access_token,
        #             'orderId':orderId,
        # #            '_aop_timestamp':self.__get_timestamp(),
        #             }
        # #        params_map['_aop_signature'] = self.__calc_signature(Command,params_map)
        #
        #         params=urllib.urlencode(params_map)
        #
        #
        #         headers={"Content-type": "application/x-www-form-urlencoded", "Accept": "text/plain"}
        #         conn = httplib.HTTPSConnection(Server)
        #
        #         conn.request('POST',Command,params,headers)
        #         response=conn.getresponse()
        #         data=response.read()
        #         conn.close()
        #         order = {}
        #         return {'result':True,'message':'Request is success.','data':order}
        #
        #     def get_order_list(self,access_token,page=1,pageSize=50,createDateStart=None,createDateEnd=None,orderStatus=None):
        #         '''
        #             交易订单列表查询
        #             @param param:
        #                 _aop_timestamp    String     否    请求时间戳
        #                 _aop_signature    String     否    请求签名
        #                 access_token    String     是    用户授权令牌
        #
        #                 page            Integer     是    当前页码        1
        #                 pageSize        Integer     是    每页个数，最大50        20
        #                 createDateStart String    否    订单创建时间起始值，格式: mm/dd/yyyy hh:mm:ss,如10/08/2013 00:00:00
        #                 createDateEnd   String    否    订单创建时间结束值，格式: mm/dd/yyyy hh:mm:ss,如10/08/2013 00:00:00
        #                 orderStatus     String    否    订单状态：
        #
        #             api.findOrderListQuery    Version:1
        #             '''
        #         if access_token is None:
        #             print 'access_token is None,Please input your access_token.'
        #             return {'result':False,'message':'Have error : access_token is None.','data':{}}
        #
        #         Server="gw.api.alibaba.com:80"
        #         Command="/openapi/param2/1/aliexpress.open/api.findOrderListQuery/"+self.appKey
        #
        #         params_map = {
        #             'access_token':access_token,
        #             'createDateEnd':createDateEnd,
        #             'createDateStart':createDateStart,
        #             'orderStatus':orderStatus,
        #             'page':page,
        #             'pageSize':pageSize,
        # #            '_aop_timestamp':self.__get_timestamp(),
        #             }
        # #        params_map['_aop_signature'] = self.__calc_signature(Command,params_map)
        #
        #         params=urllib.urlencode(params_map)
        #
        #
        #         headers={"Content-type": "application/x-www-form-urlencoded", "Accept": "text/plain"}
        #         conn = httplib.HTTPSConnection(Server)
        #
        #         conn.request('POST',Command,params,headers)
        #         response=conn.getresponse()
        #         data=response.read()
        #         conn.close()
        #         order_list = {}
        #         return {'result':True,'message':'Request is success.','data':order_list}
        #
        #     def get_order_list_simple(self,access_token,page=1,pageSize=50,createDateStart=None,createDateEnd=None,orderStatus=None):
        #         '''
        #           订单列表简化查询
        #       @param param:
        #             _aop_timestamp    String     否    请求时间戳
        #             _aop_signature    String     是    请求签名
        #             access_token    String     是    用户授权令牌
        #
        #             page            Integer     是    当前页码        1
        #             pageSize        Integer     是    每页个数，最大50        20
        #             createDateStart String    否    订单创建时间起始值，格式: mm/dd/yyyy hh:mm:ss,如10/08/2013 00:00:00
        #             createDateEnd   String    否    订单创建时间结束值，格式: mm/dd/yyyy hh:mm:ss,如10/08/2013 00:00:00
        #             orderStatus     String    否    订单状态：
        #
        #
        #
        #         api.findOrderListSimpleQuery    Version:1
        #         @return:
        #                         {
        #                 "totalItem": 总数量(SC订单不包含在结果中）,
        #                 "orderList": [
        #                     { "gmtModified": "修改时间",
        #                     "gmtCreate": "创建时间",
        #                     "memo": "订单备注", "productList": [
        #                         { "goodsPrepareTime": 备货时间, "childId": 子订单号, "sonOrderStatus": " 子订单状态", "productSnapUrl": " 快照URL", "moneyBack3x": 是否支持假一赔三, "productUnit": "商品单位", "skuCode": "商品编码", "productId": 商品ID, "productCount": 商品数量, "productUnitPrice": "商品单价", "productImgUrl": "商品主图URL", "productName": "商品名称", "productUnitPriceCur": "商品货币名称" } ],
        #                        "bizType": " 订单类型", "orderStatus": " 订单状态", "orderId": 订单ID
        #                         }
        #
        #                         ]
        #                 }
        #         '''
        #
        #         if access_token is None:
        #             print 'access_token is None,Please input your access_token.'
        #             return {'result':False,'message':'Have error : access_token is None.','data':{}}
        #
        #         Server="gw.api.alibaba.com:80"
        #         Command="/openapi/param2/1/aliexpress.open/api.findOrderListSimpleQuery/"+self.appKey
        #
        #         params_map = {
        #         'access_token':access_token,
        #         'createDateEnd':createDateEnd,
        #         'createDateStart':createDateStart,
        #         'orderStatus':orderStatus,
        #         'page':page,
        #         'pageSize':pageSize,
        # #        '_aop_timestamp':self.__get_timestamp(),
        #         }
        #         params_map['_aop_signature'] = self.__calc_signature(Command,params_map)
        #
        #         params=urllib.urlencode(params_map)
        #
        #
        #         headers={"Content-type": "application/x-www-form-urlencoded", "Accept": "text/plain"}
        #         conn = httplib.HTTPSConnection(Server)
        #
        #         conn.request('POST',Command,params,headers)
        #         response=conn.getresponse()
        #         data=response.read()
        #         conn.close()
        #         order_simple_list = {}
        #         return {'result':True,'message':'Request is success.','data':order_simple_list}


if __name__=='__main__':

    store_list = STORE_DICT_LIST
    store_name = 'ebay'
    import datetime
    st = datetime.datetime.now()
    a = Aliexpress(app_key=store_list[store_name]['app_key'], secret_key=store_list[store_name]['secret_key'], refresh_token=store_list[store_name]['refresh_token'], access_token=store_list[store_name]['access_token'], code= store_list[store_name]['code'],proxy=True,proxy_url='ec2')
    # print a.upload_image_proxy('http://sysproduct.oss-cn-shanghai.aliyuncs.com/T/TO2122MSYOF6-01.jpg')
    # requests_data = requests.get('http://sysproduct.oss-cn-shanghai.aliyuncs.com/T/TO2122MSYOF6-01.jpg')
    # with open('ddd1.jpg','rb') as f:
    #     requests_data = f.read()
    # print a.upload_image(requests_data,**{'fileName':'TO2122MSYOF6-01.jpg'})
    # print datetime.datetime.now() - st
    # params = {'productIds':'32788059358;32788059361;32785213136;32786006477;32785201895;32785209619'}
    # print a.offlineAeProduct(**params)
    # code = '3cfa5f1a-3029-4fda-89a8-751f451f6268'
    # a.get_category_tree()
    # print a.access_token


    params = {'currentPage':2}
    print a.queryIssueList(**params)


    # print a.get_authorize_url()

    # code = 'aaccea9d-1673-4e46-9de5-b3e960aab759'
    # b = a.get_token(**{'code':code})
    # print b

    # category_id = '200003190'
    # # parentAttrValueList = [[1509,200000097]]

    # 获取产品的属性列表
    # category_dict = {'cateId' : 1736}
    # attr_list, status = a.get_child_attributes_result_cateory_id_and_path(**category_dict)
    # print attr_list

    # print a.findAeProductById(**{'productId':'32637541557'})

    # 根据现有的refresh_toekn,access_token获取新的refresh_token
    # b = a.get_refresh_token_postpone_token(refresh_token, access_token)

    ###获取产品销量
    # print a.queryProductAddCartInfoEverydayById(**{'productId':'32766196923'})

    # 获取网店订单列表信息
    # temp_dict = {'page' : 1, 'pageSize' : 5, 'orderStatus' : 'WAIT_SELLER_SEND_GOODS'}
    # json_result = a.get_order_list(**temp_dict)
    # print json_result

    # 获取网店订单信息
    # temp_dict = {'orderId' : 71111397408161}
    # json_result = a.get_order(**temp_dict)
    # print json_result


    # 获取运单信息
    # temp_dict = {'warehouseOrderQueryDTOs' : [{"internationalLogisticsId":"02436464899"}]}
    # json_result = a.get_print_info(**temp_dict)
    # print json_result
    #
    # with open(json_result['Content-Disposition'].split('attachment;filename=')[1] +'.pdf','w') as temp_file:
    #     binary = a2b_base64(json_result['body'])
    #     temp_file.write(binary)
    # 店铺的运费模板
    # temp_dict = {}
    # json_result = a.list_freight_template(**temp_dict)
    # print json_result

    # 店铺的服务模板
    # temp_dict = {'templateId' : -1}
    # json_result = a.query_promise_template_id(**temp_dict)
    # print json_result

    # 店铺的产品分组
    # temp_dict = {}
    # json_result = a.get_product_group_list(**temp_dict)
    # print json_result

    # 店铺的图片分组
    # temp_dict = {'groupId' : '601641260'}
    # temp_dict = {}
    # json_result = a.get_image_group_list(**temp_dict)
    # print json_result


    # 获取系统的品类的子品类
    # category_list_total = []
    # temp_dict = {'cateId' : 0}
    # json_result = a.get_children_category(**temp_dict)
    # print json_result

    # 获取系统的各品类的品类树的xml格式
    # a.create_category_xml(200003498)


    # 上传图片进入AE
    # image_data = open('/home/Liuxl/Pictures/51m-uHIMGjL.jpg', 'rb').read()
    # temp_dict = {'fileName':'51m-uHIMGjL.jpg'}
    # json_result= a.upload_image(image_data,**temp_dict)
    # print json_result

    # 测试店铺上架产品
    # a.test_upload_product()




